/*
 Copyright:      Hagen Reddmann  mailto HaReddmann at T-Online dot de
 Author:         Hagen Reddmann
 Remarks:        this Copyright must be included
 known Problems: none
 Version:        2.1. 2004
 Description:    Graphic Library for Nokia 6100 Display and compatible
*/

.nolist
#include "glcd.inc"
#include "regs.inc"
.list

// routine 
//   void glcdRectangle(glcdCoord_t x1, glcdCoord_t y1, glcdCoord_t x2, glcdCoord_t y2);

        .text
        .global glcdRectangle           // used T0,T1,D0,D1,__temp_reg__,__zero_reg__  stack 3
glcdRectangle:
        fcall   glcdDoCheckCoord
glcdDoRectangle:
        ldi     D0, COLOR_INDEX_FG
        fcall   glcdDoGetColor
        breq    glcdRectangle1
        fcall   glcdDoSaveCoords
        mov     Y2L, Y1H
        fcall   glcdDoFillRect          // glcdDoFillRect(x1, y1, x2, y1, glcdFgColor)
        mov     X1L, X1H
        mov     X2L, X2H
        mov     Y1L, Y2H
        mov     Y2L, Y2H
        fcall   glcdDoFillRect          // glcdDoFillRect(x1, y2, x2, y2, glcdFgColor)
        mov     X1L, X1H
        mov     Y1L, Y1H
        mov     X2L, X1H
        mov     Y2L, Y2H
        fcall   glcdDoFillRect          // glcdDoFillRect(x1, y1, x1, y2, glcdFgColor)
        mov     X1L, X2H
        mov     Y1L, Y1H
        mov     X2L, X2H
        mov     Y2L, Y2H
        fcall   glcdDoFillRect          // glcdDoFillRect(x2, y1, x2, y2, glcdFgColor)
        fcall   glcdDoRestoreCoords
glcdRectangle1:
        ldi     D0, COLOR_INDEX_BK
        fcall   glcdDoGetColor
        breq    glcdRectangle2
        inc     X1
        inc     Y1
        dec     X2
        dec     Y2
        fjmp    glcdDoFillRect          // glcdDoFillRect(++x1, ++y1, --x2, --y2, glcdBkColor)
glcdRectangle2:
        ret

.end

