/*
 Copyright:      Hagen Reddmann  mailto HaReddmann at T-Online dot de
 Author:         Hagen Reddmann
 Remarks:        this Copyright must be included
 known Problems: none
 Version:        2.1. 2004
 Description:    Graphic Library for Nokia 6100 Display and compatible
*/

.nolist
#include "glcd.inc"
#include "regs.inc"
.list

        .global  glcdDoSaveCoords
glcdDoSaveCoords:
        mov     X1H, X1L                // save coords in high registers
        mov     Y1H, Y1L
        mov     X2H, X2L
        mov     Y2H, Y2L
        ret

        .global  glcdDoRestoreCoords
glcdDoRestoreCoords:                    // restore coords
        mov     X1L, X1H
        mov     Y1L, Y1H
        mov     X2L, X2H
        mov     Y2L, Y2H
        ret
.end
